#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
	int fd;
	char c;
	ssize_t len;

	if (argc < 2) {
		write(2, "usage : cat_like filename\n",26);
		return 1;
	}

	if((fd = open(argv[1], O_RDONLY)) == -1) {
		perror("open");
		return 1;
	}

	while ((len = read(fd, &c, 1)) > 0)
		write(1, &c, 1);

	close(fd);
	if (len == -1) {
		perror("read");
		return 1;
	}
	else
		return 0;
}
