// s[gT[o[vO(MINI2440:|[g3000gp)
// \PbgIvVgp
// NCAg瑗ĂԍɂLED_^

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define PORT 3000

static char *LED[] = {
	"/tmp/led0",
	"/tmp/led1",
	"/tmp/led2",
	"/tmp/led3"
};

int main (int argc, char *argv[])
{
	int fd_socket, fd_accept, index, i, buf_len;
	int led_fd[4];
	size_t len;
	struct sockaddr_in addr;
	char buff[BUFSIZ];

	if ((fd_socket = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("Server : socket :");
		return 1;
	}
	index = 1;
	setsockopt(fd_socket, SOL_SOCKET, SO_REUSEADDR, &index, sizeof(index));

	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons(PORT);

	if ((bind(fd_socket, (struct sockaddr *) &addr,
		sizeof(addr))) == -1) {
		perror("S-bind:");
		return 1;
	}
	
	if ((listen(fd_socket, 5)) == -1) {
		perror("S-listen:");
		return 1;
	}

	while(1) {
		if ((fd_accept = accept(fd_socket,
			(struct sockaddr *) &addr, &len)) == -1) {
			perror("S-accept:");
			return 1;
		}

		if ((read(fd_accept, buff, BUFSIZ)) == -1) {
			perror("S-read:");
			return 1;
		}

		index = atoi(buff);

		if (index > 15) {
			strcpy(buff, "Invalid Index.");
			goto loop_last;
		}

		buf_len = 0;
		for (i = 0; i <= 3; i++) {
			if ((led_fd[i] = open(LED[i], O_WRONLY)) == -1) {
				perror("open:");
				return 1;
			}
			strcpy(buff + buf_len, LED[i]);
			buf_len = buf_len + strlen(LED[i]);
			if ((index & (0x01 << i)) == (0x01 << i)){
				write(led_fd[i], "1", 1);
				strcpy(buff + buf_len, " : ON \n");
			}
			else{
				write(led_fd[i], "0", 1);
				strcpy(buff + buf_len, " : OFF\n");
			}
			buf_len = buf_len + 7;
			close(led_fd[i]);
		}

		if (index == 9)
			strcpy(buff + buf_len, "Server finshed.\n");

loop_last :	if ((write(fd_accept, buff, strlen(buff) + 1)) == -1) {
			perror("S-write");
			return 1;
		}

		close(fd_accept);
		if (index == 9)
			break;
	}
	close(fd_socket);

	return 0;
}
